-- phpMyAdmin SQL Dump
-- version 4.7.9
-- https://www.phpmyadmin.net/
--
-- Hôte : 127.0.0.1:3306
-- Généré le :  lun. 04 juin 2018 à 06:33
-- Version du serveur :  5.7.21
-- Version de PHP :  7.2.4

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de données :  `entrepot`
--

-- --------------------------------------------------------

--
-- Structure de la table `horaire`
--

DROP TABLE IF EXISTS `horaire`;
CREATE TABLE IF NOT EXISTS `horaire` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `login` varchar(22) NOT NULL,
  `jour` date NOT NULL,
  `debut` time NOT NULL,
  `fin` time NOT NULL,
  PRIMARY KEY (`id`),
  KEY `login` (`login`),
  KEY `jour` (`jour`),
  KEY `debut` (`debut`),
  KEY `fin` (`fin`),
  KEY `periode` (`jour`,`debut`,`fin`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPRESSED;

--
-- Déchargement des données de la table `horaire`
--

INSERT INTO `horaire` (`id`, `login`, `jour`, `debut`, `fin`) VALUES
(1, 'dendrite', '2018-06-01', '09:00:00', '12:00:00'),
(2, 'dendrite', '2018-06-01', '13:00:00', '17:15:00'),
(5, 'dendrite', '2018-06-04', '09:00:00', '12:00:00'),
(6, 'balaton', '2018-06-04', '09:00:00', '12:00:00'),
(9, 'balaton', '2018-06-01', '08:00:00', '13:00:00'),
(10, 'balaton', '2018-06-01', '14:15:00', '19:00:00'),
(11, 'dendrite', '2018-06-05', '09:00:00', '18:00:00');

--
-- Déclencheurs `horaire`
--
DROP TRIGGER IF EXISTS `insert_erreur`;
DELIMITER $$
CREATE TRIGGER `insert_erreur` BEFORE INSERT ON `horaire` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
        set _msg = concat('Insertion interdite ! Horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire where login = new.login and jour = new.jour and fin > new.debut and debut < new.fin) then
		set _msg = concat('Insertion interdite ! Les horaires recoupent des horaires déjà saisis !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
END
$$
DELIMITER ;
DROP TRIGGER IF EXISTS `update_erreur`;
DELIMITER $$
CREATE TRIGGER `update_erreur` BEFORE UPDATE ON `horaire` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
         set _msg = concat('Modification interdite ! Horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire where login = new.login and jour = new.jour and fin > new.debut and debut < new.fin) then
        set _msg = concat('Modification interdite ! Les horaires recoupent des horaires déjà saisis !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
 
END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Structure de la table `meta_sql`
--

DROP TABLE IF EXISTS `meta_sql`;
CREATE TABLE IF NOT EXISTS `meta_sql` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titre` varchar(200) COLLATE latin1_general_ci NOT NULL,
  `contenu_sql` text COLLATE latin1_general_ci NOT NULL,
  `commentaire` varchar(200) COLLATE latin1_general_ci DEFAULT NULL,
  `maj` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

--
-- Déchargement des données de la table `meta_sql`
--

INSERT INTO `meta_sql` (`id`, `titre`, `contenu_sql`, `commentaire`, `maj`) VALUES
(1, 'v_mois_agent', 'create or replace view v_mois_agent as\r\nselect distinct login, \r\ndate_format(jour,\'%Y-%m\') as mois,\r\ncast(sum(timediff(fin,debut)) as time) as cumul\r\nfrom  horaire\r\ngroup by  login, mois\r\norder by  login,mois desc', '', '2018-06-02 15:22:35'),
(2, 'v_semaine_agent', 'create or replace view v_semaine_agent as\r\nselect distinct login, \r\ndate_format(jour,\'%Y-%m Sem %u\') as semaine,\r\ncast(sum(timediff(fin,debut)) as time) as cumul\r\nfrom  horaire\r\ngroup by  login, semaine\r\norder by login, semaine desc', NULL, '2018-06-02 15:26:35'),
(3, 'v_an_agent', 'create or replace view v_an_agent as\r\nselect distinct login, \r\ndate_format(jour,\'%Y\') as an,\r\ncast(sum(timediff(fin,debut)) as time) as cumul\r\nfrom  horaire\r\ngroup by  login, an\r\norder by  login,an desc', NULL, '2018-06-02 15:18:18'),
(4, 'v_jour_agent', 'create or replace view v_jour_agent as\r\nselect distinct login, \r\njour,\r\ncast(sum(timediff(fin,debut)) as time) as cumul\r\nfrom  horaire\r\ngroup by login, jour\r\norder by login, jour desc', NULL, '2018-06-02 15:29:27'),
(5, 'v_an', 'create or replace view v_an as\r\nselect distinct date_format(jour,\'%Y\') as an,\r\ncast(sum(timediff(fin,debut)) as time) as cumul,\r\nlogin\r\nfrom  horaire\r\ngroup by an, login\r\norder by  an desc, cumul desc, login', NULL, '2018-06-02 15:32:18'),
(6, 'v_mois', 'create or replace view v_mois as\r\nselect distinct date_format(jour,\'%Y-%m\') as mois,\r\ncast(sum(timediff(fin,debut)) as time) as cumul,\r\nlogin\r\nfrom  horaire\r\ngroup by mois, login\r\norder by mois desc, cumul desc, login', NULL, '2018-06-02 15:32:45'),
(7, 'v_semaine', 'create or replace view v_semaine as\r\nselect distinct date_format(jour,\'%Y-%m Sem %u\') as semaine,\r\ncast(sum(timediff(fin,debut)) as time) as cumul,\r\nlogin\r\nfrom  horaire\r\ngroup by semaine, login\r\norder by semaine desc, cumul desc, login', NULL, '2018-06-02 15:33:12'),
(8, 'v_jour', 'create or replace view v_jour as\r\nselect distinct \r\njour,\r\ncast(sum(timediff(fin,debut)) as time) as cumul,\r\nlogin \r\nfrom  horaire\r\ngroup by jour, login\r\norder by jour desc, cumul desc, login', NULL, '2018-06-02 15:33:49');

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_an`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an`;
CREATE TABLE IF NOT EXISTS `v_an` (
`an` varchar(4)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_an_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an_agent`;
CREATE TABLE IF NOT EXISTS `v_an_agent` (
`login` varchar(22)
,`an` varchar(4)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour`;
CREATE TABLE IF NOT EXISTS `v_jour` (
`jour` date
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour_agent`;
CREATE TABLE IF NOT EXISTS `v_jour_agent` (
`login` varchar(22)
,`jour` date
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois`;
CREATE TABLE IF NOT EXISTS `v_mois` (
`mois` varchar(7)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois_agent`;
CREATE TABLE IF NOT EXISTS `v_mois_agent` (
`login` varchar(22)
,`mois` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine`;
CREATE TABLE IF NOT EXISTS `v_semaine` (
`semaine` varchar(14)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine_agent`;
CREATE TABLE IF NOT EXISTS `v_semaine_agent` (
`login` varchar(22)
,`semaine` varchar(14)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Structure de la vue `v_an`
--
DROP TABLE IF EXISTS `v_an`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an`  AS  select date_format(`horaire`.`jour`,'%Y') AS `an`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by `an`,`horaire`.`login` order by `an` desc,`cumul` desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_an_agent`
--
DROP TABLE IF EXISTS `v_an_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an_agent`  AS  select `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y') AS `an`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul` from `horaire` group by `horaire`.`login`,`an` order by `horaire`.`login`,`an` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour`
--
DROP TABLE IF EXISTS `v_jour`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour`  AS  select `horaire`.`jour` AS `jour`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by `horaire`.`jour`,`horaire`.`login` order by `horaire`.`jour` desc,`cumul` desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour_agent`
--
DROP TABLE IF EXISTS `v_jour_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour_agent`  AS  select `horaire`.`login` AS `login`,`horaire`.`jour` AS `jour`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul` from `horaire` group by `horaire`.`login`,`horaire`.`jour` order by `horaire`.`login`,`horaire`.`jour` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois`
--
DROP TABLE IF EXISTS `v_mois`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois`  AS  select date_format(`horaire`.`jour`,'%Y-%m') AS `mois`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by `mois`,`horaire`.`login` order by `mois` desc,`cumul` desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois_agent`
--
DROP TABLE IF EXISTS `v_mois_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois_agent`  AS  select `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y-%m') AS `mois`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul` from `horaire` group by `horaire`.`login`,`mois` order by `horaire`.`login`,`mois` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine`
--
DROP TABLE IF EXISTS `v_semaine`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine`  AS  select date_format(`horaire`.`jour`,'%Y-%m Sem %u') AS `semaine`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by `semaine`,`horaire`.`login` order by `semaine` desc,`cumul` desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine_agent`
--
DROP TABLE IF EXISTS `v_semaine_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine_agent`  AS  select `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y-%m Sem %u') AS `semaine`,cast(sum(timediff(`horaire`.`fin`,`horaire`.`debut`)) as time) AS `cumul` from `horaire` group by `horaire`.`login`,`semaine` order by `horaire`.`login`,`semaine` desc ;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
